//=============================================================================
// STPortalMut.
//=============================================================================
class STPortalMut expands MutatorPlus config (STPortalMut);

var playerpawn CleanUp;
var string PName;
var actor a;
struct MapAndLoc
{
var() config string LvlName;
var() config vector SpawnLoc;
var() config vector SecondLoc;
};
var string ThisMap;
var() config bool bMain;
var() config bool bLounge;
var string Owners[20];
var string OwnerNames[20];
var() config MapAndLoc PortalSpawn[50];
var int i;
replication
{
reliable if(role == 4)
bMain, bLounge;
}

function PostBeginPlay()
{
       local int q;
local int s;
        local vector GoHere;
local int derp;

ThisMap = Level.GetLocalURL();

S = InStr(ThisMap,"/") + 1;
  Q = InStr(ThisMap,"?");
  ThisMap = Mid(ThisMap,S,Q - S);
  if ( InStr(Caps(ThisMap),".UNR") == -1 )
  {
    ThisMap = ThisMap $ ".unr";
  }

for(derp=0;derp<50;derp++)
{
if(thismap~=PortalSpawn[derp].LvlName)
{
if(bMain)
spawn(class'TULPortal',,,PortalSpawn[derp].SpawnLoc);
else
if(bLounge)
spawn(class'TUMPortal',,,PortalSpawn[derp].SpawnLoc);
else
spawn(class'TUMPortal',,,PortalSpawn[derp].SpawnLoc);

if(Portalspawn[derp].secondloc.x!=0)
{
if(bMain)
spawn(class'TULPortal',,,PortalSpawn[derp].SpawnLoc);
else
if(bLounge)
spawn(class'TUMPortal',,,PortalSpawn[derp].SpawnLoc);
else
spawn(class'TUMPortal',,,PortalSpawn[derp].SpawnLoc);
}
}
}
super.postbeginplay();
}

simulated function MutateExitingPlayer( pawn Exiting )
{

if(bLounge && exiting.isa('playerpawn'))
{

log("Begin CleanUp for "$exiting.playerreplicationinfo.playername);
PName=exiting.playerreplicationinfo.playername;
foreach allactors(class'actor',a)
{
if(a != exiting && !a.isa('playerreplicationinfo') && a.tag != 'MInv' && (a.owner == exiting || a.instigator == exiting))
{
log("STPORTALMUT: Cleaning up "$a$", created by "$exiting.playerreplicationinfo.playername);
a.destroy();
}
}
CleanStuff();

}


super.mutateexitingplayer(exiting);

}

simulated function CleanStuff()
{
foreach allactors(class'actor',a)
{
if(a.tag == 'MInv')
{
log("STPORTALMUT: Cleaning up "$a$", created by "$PName);
a.destroy();
}
}
}


/*
simulated function RemoveSpawned(int PNum)
{
local actor ac;
local name derp;

Derp='';

foreach allactors(class'actor',ac)
{
if(AC.Tag == PNum)
AC.Destroy();
}
}
*/

// OLD TESTS /////////

/*


if(bLounge)
{
If(exiting.isa('playerpawn'))
{
CleanUp=Playerpawn(Exiting);
CleanUp.Disable('Destroyed');
GoToState('Cleaning');
}
}



state Cleaning
{
begin:
if(CleanUp!=none)
{
CleanUp.Sleep(2.0);
Cleanup.ClientMessage("Cleaning up your creations...");
log("Begin CleanUp for "$cleanup.playerreplicationinfo.playername);

foreach allactors(class'actor',a)
{
if(a != cleanup && !a.isa('playerreplicationinfo') && (a.owner == cleanup || a.instigator == cleanup))
{
log("Cleaning up "$a$", created by "$cleanup.playerreplicationinfo.playername);
a.setphysics(phys_falling);
a.balwaysrelevant=true;
a.destroy();
}
}
}
Cleanup.ClientMessage("Done! Goodbye!");
CleanUp.Enable('Destroyed');
Cleanup=None;
}




// local actor a;

if(bLounge)
{
Owners[i]=string(exiting);
OwnerNames[i]=exiting.playerreplicationinfo.playername;
i++;
settimer(0.001,false);
}


simulated function timer()
{
local int n, x;
local int w;
local actor a;
local string CurOwner;
for(x=0;x<20;x++)
{
if(Owners[x]!="")
N++;
}

for(w=0;w<n;w++)
{

log("Begin CleanUp for "$OwnerNames[w]);

foreach allactors(class'actor',a)
{
CurOwner=string(a.owner);
log(curowner);
if(!a.isa('playerreplicationinfo') && (CurOwner == Owners[w] || CurOwner == Owners[w]))
{
log("Cleaning up "$a$", created by "$OwnerNames[w]);
a.destroy();
}
}
CurOwner = "";
OwnerNames[w]="";
Owners[w]="";
}
w=0;
n=0;
x=0;
i=0;
}
*/

defaultproperties
{
				PortalSpawn(0)=(LvlName="Vortex2.UNR",SpawnLoc=(X=-2584.263672,Y=281.622314,Z=-436.200012))
				PortalSpawn(1)=(LvlName="Nyleve.UNR",SpawnLoc=(X=3182.604980,Y=-7422.766113,Z=-1202.099976))
				PortalSpawn(2)=(LvlName="Dig.UNR",SpawnLoc=(X=-1154.454468,Y=1275.095459,Z=-20.199999))
				PortalSpawn(3)=(LvlName="Dug.UNR",SpawnLoc=(X=7425.646484,Y=1666.934937,Z=-644.200012))
				PortalSpawn(4)=(LvlName="Passage.UNR",SpawnLoc=(X=3114.958740,Y=1282.764648,Z=-86.099998))
				PortalSpawn(5)=(LvlName="Chizra.UNR",SpawnLoc=(X=-6674.208984,Y=4259.182617,Z=1003.900024))
				PortalSpawn(6)=(LvlName="Ceremony.UNR",SpawnLoc=(X=-1866.398315,Y=4.871167,Z=195.899994))
				PortalSpawn(7)=(LvlName="Dark.UNR",SpawnLoc=(X=-5634.417969,Y=6951.434082,Z=579.799988))
				PortalSpawn(8)=(LvlName="Harobed.UNR",SpawnLoc=(X=-9002.573242,Y=2655.488770,Z=-580.200012))
				PortalSpawn(9)=(LvlName="TerraLift.UNR",SpawnLoc=(X=-1172.240356,Y=369.577179,Z=-84.099998))
				PortalSpawn(10)=(LvlName="Terraniux.UNR",SpawnLoc=(X=703.165222,Y=-11161.999023,Z=-340.299988))
				PortalSpawn(11)=(LvlName="Noork.UNR",SpawnLoc=(X=-4492.712891,Y=3550.769531,Z=-884.200012))
				PortalSpawn(12)=(LvlName="Ruins.UNR",SpawnLoc=(X=-1316.382935,Y=-10.069290,Z=43.700001))
				PortalSpawn(13)=(LvlName="Trench.UNR",SpawnLoc=(X=8140.435059,Y=2977.459229,Z=-570.200012))
				PortalSpawn(14)=(LvlName="ISVKran4.UNR",SpawnLoc=(X=486.688019,Y=-10945.433594,Z=-1748.199951))
				PortalSpawn(15)=(LvlName="ISVKran32.UNR",SpawnLoc=(X=102.472961,Y=-6176.132813,Z=-1428.199951))
				PortalSpawn(16)=(LvlName="ISVDeck1.UNR",SpawnLoc=(X=3.546585,Y=-1516.758911,Z=-388.100006))
				PortalSpawn(17)=(LvlName="SpireVillage.UNR",SpawnLoc=(X=-14436.018555,Y=14327.585938,Z=-7841.200195))
				PortalSpawn(18)=(LvlName="TheSunspire.UNR",SpawnLoc=(X=-10726.943359,Y=8999.626953,Z=-9212.200195),SecondLoc=(X=2573.605469,Y=2964.787354,Z=-11113.200195))
				PortalSpawn(19)=(LvlName="SkyCaves.UNR",SpawnLoc=(X=-2220.900391,Y=-2395.887207,Z=11.799999))
				PortalSpawn(20)=(LvlName="SkyTown.UNR",SpawnLoc=(X=1708.796143,Y=-4206.945801,Z=1707.699951))
				PortalSpawn(21)=(LvlName="skybase.UNR",SpawnLoc=(X=1661.134155,Y=3080.580078,Z=2443.800049))
				PortalSpawn(22)=(LvlName="veloraend.UNR",SpawnLoc=(X=-894.455017,Y=-7051.837402,Z=367.899994))
				PortalSpawn(23)=(LvlName="bluff.UNR",SpawnLoc=(X=234.582840,Y=10932.145508,Z=-3796.300049))
				PortalSpawn(24)=(LvlName="dasapass.UNR",SpawnLoc=(X=-3036.137207,Y=2953.275879,Z=-640.099976))
				PortalSpawn(25)=(LvlName="dasacellars.UNR",SpawnLoc=(X=5706.260742,Y=371.157928,Z=-324.100006))
				PortalSpawn(26)=(LvlName="naliboat.UNR",SpawnLoc=(X=-9751.233398,Y=4374.101563,Z=2923.700439))
				PortalSpawn(27)=(LvlName="nalic.UNR",SpawnLoc=(X=198.026474,Y=-5965.683594,Z=3116.574951))
				PortalSpawn(28)=(LvlName="nalilord.UNR",SpawnLoc=(X=4018.170166,Y=534.372498,Z=323.900726))
				PortalSpawn(29)=(LvlName="dcrater.UNR",SpawnLoc=(X=-15342.195313,Y=-174.197830,Z=-4196.200195))
				PortalSpawn(30)=(LvlName="extremebeg.UNR",SpawnLoc=(X=-38.386463,Y=-1334.108154,Z=-84.299973))
				PortalSpawn(31)=(LvlName="extremelab.UNR",SpawnLoc=(X=2442.245605,Y=-408.815094,Z=-724.100037))
				PortalSpawn(32)=(LvlName="extremecore.UNR",SpawnLoc=(X=-1585.687988,Y=-329.525635,Z=-340.100006),SecondLoc=(X=-2128.101807,Y=880.912659,Z=-84.260735))
				PortalSpawn(33)=(LvlName="extremegen.UNR",SpawnLoc=(X=-1530.380615,Y=-9.874496,Z=-472.200012))
				PortalSpawn(34)=(LvlName="extremedgen.UNR",SpawnLoc=(X=24421.906250,Y=78.983025,Z=-767.488159))
				PortalSpawn(35)=(LvlName="extremedark.UNR",SpawnLoc=(X=2030.967529,Y=1631.439209,Z=-84.199997))
				PortalSpawn(36)=(LvlName="extremeend.UNR",SpawnLoc=(X=203.095322,Y=-1083.701050,Z=-84.099937))
				PortalSpawn(37)=(LvlName="queenend.UNR",SpawnLoc=(X=-14157.978516,Y=-2247.454834,Z=43.700001))
				PortalSpawn(38)=(LvlName="IslandsSnow.UNR",SpawnLoc=(X=-18154.853516,Y=10704.530273,Z=-11364.200195))
}
